/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSPREFS_H
#define KSPREFS_H

#include <kdialogbase.h>

class PageGeneral;
class PageColors;
class PageStartup;
/*
class PageRMBMenu;
class PageServChan;
*/


class PageFont; /* For the font settings */


class KSPrefs : public KDialogBase
{

Q_OBJECT
public:
    KSPrefs(QWidget * parent = 0, const char * name = 0);
    ~KSPrefs();

public slots:
    void saveConfig();
    void defaultConfig();
    void readConfig();
    void modified();

signals:
    void update(int);

private:
    PageColors   *pageColors;
    PageGeneral  *pageGeneral;
//    PageRMBMenu  *pageRMBMenu;
    PageStartup  *pageStartup;
//    PageServChan *pageServChan;

    PageFont *pageFont; /* Font settings page */
    int dirty;
};

#endif
